// distance.c   // 
#include"mex.h"
#include"math.h"
void distance(double *mdist, const double *ddgcv, const double *classnumber, const double *classcg,
   const double *maxcg, const double *aaag, const double *nn, const double *ddim, const double *vvvg){
   int j, addr, addrv, addraa, addr2, addraaclass, addrdist, d, d2, class, c, classn, n, dim, sizeaa;
   double mdistv[100], dist, ddcv[100], mmgc, t1, t2;
// ------------------------
   t1=clock(); classn=(int)*classnumber; n=(int)*nn; dim=(int)*ddim; sizeaa=(int)((dim-1)*(dim-1)); addr=0; addr2=0;
for(j=0;j<n;j++){      addrv=0; addraaclass=0; addrdist=0;
   for(class=0;class<classn;class++){    
      for(c=0;c<(int)classcg[class];c++){
          for(d=0;d<dim-1;d++){mdistv[d]=0;}
          for(d=0;d<dim-1;d++){     ddcv[d]=ddgcv[addr+d+1]-vvvg[addrv+d]; addraa=0; 
              for(d2=0;d2<dim-1;d2++){mdistv[d2]+=(aaag[addraaclass+addraa+d])*ddcv[d]; addraa=addraa+dim-1;} // d2
          } // d
          dist=0; for(d2=0;d2<dim-1;d2++){dist+=mdistv[d2]*ddcv[d2];} // d2
          mdist[addr2+addrdist+c]=dist; if(dist<0){mexPrintf("Negative distance \n");}
          addrv+=(dim-1); addraaclass+=sizeaa;
      } // c
      addrdist+=(int)*maxcg;
   } //class
  addr2+=classn*(int)*maxcg; addr+=dim; 
} // j
 t2=clock(); printf("elapse time= %7.0f\n", t2-t1); 
} // void
void mexFunction( int Nreturned, mxArray *returned[], int Noperand, const mxArray *operand[]){
  double *mdist, *ddgcv, *classnumber, *classcg, *maxcg, *aaag, *nn, *ddim, *vvvg;
  /* Matlab variables are copied to address of C variables */
  ddgcv = mxGetPr(operand[0]);  classnumber = mxGetPr(operand[1]);  classcg= mxGetPr(operand[2]); maxcg= mxGetPr(operand[3]); 
  aaag= mxGetPr(operand[4]); nn= mxGetPr(operand[5]); ddim= mxGetPr(operand[6]); vvvg= mxGetPr(operand[7]); 
    returned[0] = mxCreateDoubleMatrix((int)*maxcg*(*classnumber),(int)*nn,mxREAL);
  mdist = mxGetPr(returned[0]); // return variable
  distance(mdist,ddgcv,classnumber,classcg,maxcg,aaag,nn,ddim,vvvg);
}

